/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Fri Apr 15 16:16:01 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-dte/oss20212gen/LibItsCam_asn1.gen DENM.asn CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.*;

/**
 * Define the ASN1 Type DecentralizedSituation from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class DecentralizedSituation extends Sequence {
    
    /**
     * The default constructor.
     */
    public DecentralizedSituation()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public DecentralizedSituation(TrafficFlowEffect trafficFlowEffect, 
		    Situation situation, Situation linkedCause, 
		    Severity severity, EventCharact eventCharact, 
		    VehicleCommonParameters vehicleCommonParameters, 
		    ProfileParameters profile)
    {
	setTrafficFlowEffect(trafficFlowEffect);
	setSituation(situation);
	setLinkedCause(linkedCause);
	setSeverity(severity);
	setEventCharact(eventCharact);
	setVehicleCommonParameters(vehicleCommonParameters);
	setProfile(profile);
    }
    
    /**
     * Construct with required components.
     */
    public DecentralizedSituation(Situation situation, Severity severity)
    {
	setSituation(situation);
	setSeverity(severity);
    }
    
    public void initComponents()
    {
	mComponents[0] = new TrafficFlowEffect();
	mComponents[1] = new Situation();
	mComponents[2] = new Situation();
	mComponents[3] = Severity.informative;
	mComponents[4] = new EventCharact();
	mComponents[5] = new VehicleCommonParameters();
	mComponents[6] = new ProfileParameters();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[7];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new TrafficFlowEffect();
	    case 1:
		return new Situation();
	    case 2:
		return new Situation();
	    case 3:
		return Severity.informative;
	    case 4:
		return new EventCharact();
	    case 5:
		return new VehicleCommonParameters();
	    case 6:
		return new ProfileParameters();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "trafficFlowEffect"
    public TrafficFlowEffect getTrafficFlowEffect()
    {
	return (TrafficFlowEffect)mComponents[0];
    }
    
    public void setTrafficFlowEffect(TrafficFlowEffect trafficFlowEffect)
    {
	mComponents[0] = trafficFlowEffect;
    }
    
    public boolean hasTrafficFlowEffect()
    {
	return componentIsPresent(0);
    }
    
    public void deleteTrafficFlowEffect()
    {
	setComponentAbsent(0);
    }
    
    
    // Methods for field "situation"
    public Situation getSituation()
    {
	return (Situation)mComponents[1];
    }
    
    public void setSituation(Situation situation)
    {
	mComponents[1] = situation;
    }
    
    
    // Methods for field "linkedCause"
    public Situation getLinkedCause()
    {
	return (Situation)mComponents[2];
    }
    
    public void setLinkedCause(Situation linkedCause)
    {
	mComponents[2] = linkedCause;
    }
    
    public boolean hasLinkedCause()
    {
	return componentIsPresent(2);
    }
    
    public void deleteLinkedCause()
    {
	setComponentAbsent(2);
    }
    
    
    // Methods for field "severity"
    public Severity getSeverity()
    {
	return (Severity)mComponents[3];
    }
    
    public void setSeverity(Severity severity)
    {
	mComponents[3] = severity;
    }
    
    
    // Methods for field "eventCharact"
    public EventCharact getEventCharact()
    {
	return (EventCharact)mComponents[4];
    }
    
    public void setEventCharact(EventCharact eventCharact)
    {
	mComponents[4] = eventCharact;
    }
    
    public boolean hasEventCharact()
    {
	return componentIsPresent(4);
    }
    
    public void deleteEventCharact()
    {
	setComponentAbsent(4);
    }
    
    
    
    /**
     * Define the ASN1 Type EventCharact from ASN1 Module DENM_PDU_Descriptions.
     * @see Sequence
     */
    public static class EventCharact extends Sequence {
	
	/**
	 * The default constructor.
	 */
	public EventCharact()
	{
	}
	
	/**
	 * Construct with AbstractData components.
	 */
	public EventCharact(BOOLEAN eventmobility, CauseType causeType, 
			Relevance relevance, BOOLEAN timeCriticality)
	{
	    setEventmobility(eventmobility);
	    setCauseType(causeType);
	    setRelevance(relevance);
	    setTimeCriticality(timeCriticality);
	}
	
	/**
	 * Construct with components.
	 */
	public EventCharact(boolean eventmobility, CauseType causeType, 
			Relevance relevance, boolean timeCriticality)
	{
	    this(new BOOLEAN(eventmobility), causeType, relevance, 
		 new BOOLEAN(timeCriticality));
	}
	
	public void initComponents()
	{
	    mComponents[0] = new BOOLEAN();
	    mComponents[1] = CauseType.itsStation;
	    mComponents[2] = Relevance.physicallyRelevant;
	    mComponents[3] = new BOOLEAN();
	}
	
	// Instance initializer
	{
	    mComponents = new AbstractData[4];
	}
	
	// Method to create a specific component instance
	public AbstractData createInstance(int index)
	{
	    switch (index) {
		case 0:
		    return new BOOLEAN();
		case 1:
		    return CauseType.itsStation;
		case 2:
		    return Relevance.physicallyRelevant;
		case 3:
		    return new BOOLEAN();
		default:
		    throw new InternalError("AbstractCollection.createInstance()");
	    }
	    
	}
	
	
	// Methods for field "eventmobility"
	public boolean getEventmobility()
	{
	    return ((BOOLEAN)mComponents[0]).booleanValue();
	}
	
	public void setEventmobility(boolean eventmobility)
	{
	    setEventmobility(new BOOLEAN(eventmobility));
	}
	
	public void setEventmobility(BOOLEAN eventmobility)
	{
	    mComponents[0] = eventmobility;
	}
	
	
	// Methods for field "causeType"
	public CauseType getCauseType()
	{
	    return (CauseType)mComponents[1];
	}
	
	public void setCauseType(CauseType causeType)
	{
	    mComponents[1] = causeType;
	}
	
	
	
	/**
	 * Define the ASN1 Type CauseType from ASN1 Module DENM_PDU_Descriptions.
	 * @see Enumerated
	 */
	public static final class CauseType extends Enumerated {
	    
	    /**
	     * The default constructor.
	     */
	    private CauseType()
	    {
		super(cFirstNumber);
	    }
	    
	    protected CauseType(long value)
	    {
		super(value);
	    }
	    
	    // Named list definitions.
	    public static final CauseType itsStation =
		new CauseType(0);
	    public static final CauseType geographicalRegion =
		new CauseType(1);
	    private final static CauseType cNamedNumbers[] = {
		 itsStation, 
		 geographicalRegion
	    };
	    protected final static long cFirstNumber = 0;
	    protected final static boolean cLinearNumbers = false;
	    
	    public Enumerated[] getNamedNumbers()
	    {
		return cNamedNumbers;
	    }
	    
	    public boolean hasLinearNumbers()
	    {
		return cLinearNumbers;
	    }
	    
	    public long getFirstNumber()
	    {
		return cFirstNumber;
	    }
	    
	    public static CauseType valueOf(long value)
	    {
		return (CauseType)itsStation.lookupValue(value);
	    }
	    
	    /**
	     * Initialize the type descriptor.
	     */
	    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
		new Tags (
		    new short[] {
			(short)0x8001
		    }
		),
		new QName (
		    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
		    "DecentralizedSituation$EventCharact$CauseType"
		),
		new QName (
		    "builtin",
		    "ENUMERATED"
		),
		12314,
		null,
		new MemberList (
		    new MemberListElement[] {
			new MemberListElement (
			    "itsStation",
			    0
			),
			new MemberListElement (
			    "geographicalRegion",
			    1
			)
		    }
		),
		0,
		itsStation
	    );
	    
	    /**
	     * Get the type descriptor (TypeInfo) of 'this' CauseType object.
	     */
	    public TypeInfo getTypeInfo()
	    {
		return c_typeinfo;
	    }
	    
	    /**
	     * Get the static type descriptor (TypeInfo) of 'this' CauseType object.
	     */
	    public static TypeInfo getStaticTypeInfo()
	    {
		return c_typeinfo;
	    }
	    
	} // End class definition for CauseType

	// Methods for field "relevance"
	public Relevance getRelevance()
	{
	    return (Relevance)mComponents[2];
	}
	
	public void setRelevance(Relevance relevance)
	{
	    mComponents[2] = relevance;
	}
	
	
	
	/**
	 * Define the ASN1 Type Relevance from ASN1 Module DENM_PDU_Descriptions.
	 * @see Enumerated
	 */
	public static final class Relevance extends Enumerated {
	    
	    /**
	     * The default constructor.
	     */
	    private Relevance()
	    {
		super(cFirstNumber);
	    }
	    
	    protected Relevance(long value)
	    {
		super(value);
	    }
	    
	    // Named list definitions.
	    public static final Relevance physicallyRelevant =
		new Relevance(0);
	    public static final Relevance difficultDrivingConditions =
		new Relevance(1);
	    private final static Relevance cNamedNumbers[] = {
		 physicallyRelevant, 
		 difficultDrivingConditions
	    };
	    protected final static long cFirstNumber = 0;
	    protected final static boolean cLinearNumbers = false;
	    
	    public Enumerated[] getNamedNumbers()
	    {
		return cNamedNumbers;
	    }
	    
	    public boolean hasLinearNumbers()
	    {
		return cLinearNumbers;
	    }
	    
	    public long getFirstNumber()
	    {
		return cFirstNumber;
	    }
	    
	    public static Relevance valueOf(long value)
	    {
		return (Relevance)physicallyRelevant.lookupValue(value);
	    }
	    
	    /**
	     * Initialize the type descriptor.
	     */
	    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
		new Tags (
		    new short[] {
			(short)0x8002
		    }
		),
		new QName (
		    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
		    "DecentralizedSituation$EventCharact$Relevance"
		),
		new QName (
		    "builtin",
		    "ENUMERATED"
		),
		12314,
		null,
		new MemberList (
		    new MemberListElement[] {
			new MemberListElement (
			    "physicallyRelevant",
			    0
			),
			new MemberListElement (
			    "difficultDrivingConditions",
			    1
			)
		    }
		),
		0,
		physicallyRelevant
	    );
	    
	    /**
	     * Get the type descriptor (TypeInfo) of 'this' Relevance object.
	     */
	    public TypeInfo getTypeInfo()
	    {
		return c_typeinfo;
	    }
	    
	    /**
	     * Get the static type descriptor (TypeInfo) of 'this' Relevance object.
	     */
	    public static TypeInfo getStaticTypeInfo()
	    {
		return c_typeinfo;
	    }
	    
	} // End class definition for Relevance

	// Methods for field "timeCriticality"
	public boolean getTimeCriticality()
	{
	    return ((BOOLEAN)mComponents[3]).booleanValue();
	}
	
	public void setTimeCriticality(boolean timeCriticality)
	{
	    setTimeCriticality(new BOOLEAN(timeCriticality));
	}
	
	public void setTimeCriticality(BOOLEAN timeCriticality)
	{
	    mComponents[3] = timeCriticality;
	}
	
	
	/**
	 * Initialize the type descriptor.
	 */
	private static final SequenceInfo c_typeinfo = new SequenceInfo (
	    new Tags (
		new short[] {
		    (short)0x8004
		}
	    ),
	    new QName (
		"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
		"DecentralizedSituation$EventCharact"
	    ),
	    new QName (
		"builtin",
		"SEQUENCE"
	    ),
	    12318,
	    null,
	    new Fields (
		new SequenceFieldInfo[] {
		    new SequenceFieldInfo (
			new TypeInfoRef (
			    new TypeInfo (
				new Tags (
				    new short[] {
					(short)0x8000
				    }
				),
				new QName (
				    "com.oss.asn1",
				    "BOOLEAN"
				),
				new QName (
				    "builtin",
				    "BOOLEAN"
				),
				12314,
				null
			    )
			),
			"eventmobility",
			0,
			2,
			null
		    ),
		    new SequenceFieldInfo (
			new TypeInfoRef (
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"DecentralizedSituation$EventCharact$CauseType"
			    )
			),
			"causeType",
			1,
			2,
			null
		    ),
		    new SequenceFieldInfo (
			new TypeInfoRef (
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"DecentralizedSituation$EventCharact$Relevance"
			    )
			),
			"relevance",
			2,
			2,
			null
		    ),
		    new SequenceFieldInfo (
			new TypeInfoRef (
			    new TypeInfo (
				new Tags (
				    new short[] {
					(short)0x8003
				    }
				),
				new QName (
				    "com.oss.asn1",
				    "BOOLEAN"
				),
				new QName (
				    "builtin",
				    "BOOLEAN"
				),
				12314,
				null
			    )
			),
			"timeCriticality",
			3,
			2,
			null
		    )
		}
	    ),
	    0,
	    new TagDecoders (
		new TagDecoder[] {
		    new TagDecoder (
			new TagDecoderElement[] {
			    new TagDecoderElement((short)0x8000, 0)
			}
		    ),
		    new TagDecoder (
			new TagDecoderElement[] {
			    new TagDecoderElement((short)0x8001, 1)
			}
		    ),
		    new TagDecoder (
			new TagDecoderElement[] {
			    new TagDecoderElement((short)0x8002, 2)
			}
		    ),
		    new TagDecoder (
			new TagDecoderElement[] {
			    new TagDecoderElement((short)0x8003, 3)
			}
		    )
		}
	    ),
	    0
	);
	
	/**
	 * Get the type descriptor (TypeInfo) of 'this' EventCharact object.
	 */
	public TypeInfo getTypeInfo()
	{
	    return c_typeinfo;
	}
	
	/**
	 * Get the static type descriptor (TypeInfo) of 'this' EventCharact object.
	 */
	public static TypeInfo getStaticTypeInfo()
	{
	    return c_typeinfo;
	}
	
    } // End class definition for EventCharact

    // Methods for field "vehicleCommonParameters"
    public VehicleCommonParameters getVehicleCommonParameters()
    {
	return (VehicleCommonParameters)mComponents[5];
    }
    
    public void setVehicleCommonParameters(VehicleCommonParameters vehicleCommonParameters)
    {
	mComponents[5] = vehicleCommonParameters;
    }
    
    public boolean hasVehicleCommonParameters()
    {
	return componentIsPresent(5);
    }
    
    public void deleteVehicleCommonParameters()
    {
	setComponentAbsent(5);
    }
    
    
    // Methods for field "profile"
    public ProfileParameters getProfile()
    {
	return (ProfileParameters)mComponents[6];
    }
    
    public void setProfile(ProfileParameters profile)
    {
	mComponents[6] = profile;
    }
    
    public boolean hasProfile()
    {
	return componentIsPresent(6);
    }
    
    public void deleteProfile()
    {
	setComponentAbsent(6);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
	    "DecentralizedSituation"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "DecentralizedSituation"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"TrafficFlowEffect"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"TrafficFlowEffect"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new TrafficFlowEffect(0), 
				    new TrafficFlowEffect(7),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(7)
			    ),
			    null
			)
		    ),
		    "trafficFlowEffect",
		    0,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"Situation"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Situation"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				    "Situation"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				    "Situation"
				)
			    ),
			    0
			)
		    ),
		    "situation",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"Situation"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Situation"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				    "Situation"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				    "Situation"
				)
			    ),
			    0
			)
		    ),
		    "linkedCause",
		    2,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"Severity"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Severity"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"informative",
					1
				    ),
				    new MemberListElement (
					"obstacles",
					2
				    ),
				    new MemberListElement (
					"danger",
					3
				    ),
				    new MemberListElement (
					"highestDanger",
					4
				    )
				}
			    ),
			    0,
			    Severity.informative
			)
		    ),
		    "severity",
		    3,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new QName (
			    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
			    "DecentralizedSituation$EventCharact"
			)
		    ),
		    "eventCharact",
		    4,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8005
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"VehicleCommonParameters"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"VehicleCommonParameters"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				    "VehicleCommonParameters"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				    "VehicleCommonParameters"
				)
			    ),
			    0
			)
		    ),
		    "vehicleCommonParameters",
		    5,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ChoiceInfo (
			    new Tags (
				new short[] {
				    (short)0x8006
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"ProfileParameters"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"ProfileParameters"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				    "ProfileParameters"
				)
			    ),
			    0,
			    new TagDecoder (
				new TagDecoderElement[] {
				    new TagDecoderElement((short)0x8000, 0),
				    new TagDecoderElement((short)0x8001, 1),
				    new TagDecoderElement((short)0x8002, 2)
				}
			    )
			)
		    ),
		    "profile",
		    6,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0),
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8006, 6)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' DecentralizedSituation object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' DecentralizedSituation object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for DecentralizedSituation
