/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm-pdu-descriptions */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Tue Jun 28 12:09:14 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -per -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6535gen/LibItsDenm_asn1.gen DENM-PDU-Descriptions.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.*;

/**
 * Define the ASN1 Type ReferencePosition from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class ReferencePosition extends Sequence {
    
    /**
     * The default constructor.
     */
    public ReferencePosition()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public ReferencePosition(Longitude longitude, Latitude latitude, 
		    Elevation elevation, Direction heading, 
		    StreetName streetName, Confidence positionConfidence, 
		    Confidence elevationConfidence, 
		    RoadSegmentID roadSegmentID)
    {
	setLongitude(longitude);
	setLatitude(latitude);
	setElevation(elevation);
	setHeading(heading);
	setStreetName(streetName);
	setPositionConfidence(positionConfidence);
	setElevationConfidence(elevationConfidence);
	setRoadSegmentID(roadSegmentID);
    }
    
    /**
     * Construct with required components.
     */
    public ReferencePosition(Longitude longitude, Latitude latitude, 
		    Elevation elevation)
    {
	setLongitude(longitude);
	setLatitude(latitude);
	setElevation(elevation);
    }
    
    public void initComponents()
    {
	mComponents[0] = new Longitude();
	mComponents[1] = new Latitude();
	mComponents[2] = new Elevation();
	mComponents[3] = new Direction();
	mComponents[4] = new StreetName();
	mComponents[5] = new Confidence();
	mComponents[6] = new Confidence();
	mComponents[7] = new RoadSegmentID();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[8];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new Longitude();
	    case 1:
		return new Latitude();
	    case 2:
		return new Elevation();
	    case 3:
		return new Direction();
	    case 4:
		return new StreetName();
	    case 5:
		return new Confidence();
	    case 6:
		return new Confidence();
	    case 7:
		return new RoadSegmentID();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "longitude"
    public Longitude getLongitude()
    {
	return (Longitude)mComponents[0];
    }
    
    public void setLongitude(Longitude longitude)
    {
	mComponents[0] = longitude;
    }
    
    
    // Methods for field "latitude"
    public Latitude getLatitude()
    {
	return (Latitude)mComponents[1];
    }
    
    public void setLatitude(Latitude latitude)
    {
	mComponents[1] = latitude;
    }
    
    
    // Methods for field "elevation"
    public Elevation getElevation()
    {
	return (Elevation)mComponents[2];
    }
    
    public void setElevation(Elevation elevation)
    {
	mComponents[2] = elevation;
    }
    
    
    // Methods for field "heading"
    public Direction getHeading()
    {
	return (Direction)mComponents[3];
    }
    
    public void setHeading(Direction heading)
    {
	mComponents[3] = heading;
    }
    
    public boolean hasHeading()
    {
	return componentIsPresent(3);
    }
    
    public void deleteHeading()
    {
	setComponentAbsent(3);
    }
    
    
    // Methods for field "streetName"
    public StreetName getStreetName()
    {
	return (StreetName)mComponents[4];
    }
    
    public void setStreetName(StreetName streetName)
    {
	mComponents[4] = streetName;
    }
    
    public boolean hasStreetName()
    {
	return componentIsPresent(4);
    }
    
    public void deleteStreetName()
    {
	setComponentAbsent(4);
    }
    
    
    // Methods for field "positionConfidence"
    public Confidence getPositionConfidence()
    {
	return (Confidence)mComponents[5];
    }
    
    public void setPositionConfidence(Confidence positionConfidence)
    {
	mComponents[5] = positionConfidence;
    }
    
    public boolean hasPositionConfidence()
    {
	return componentIsPresent(5);
    }
    
    public void deletePositionConfidence()
    {
	setComponentAbsent(5);
    }
    
    
    // Methods for field "elevationConfidence"
    public Confidence getElevationConfidence()
    {
	return (Confidence)mComponents[6];
    }
    
    public void setElevationConfidence(Confidence elevationConfidence)
    {
	mComponents[6] = elevationConfidence;
    }
    
    public boolean hasElevationConfidence()
    {
	return componentIsPresent(6);
    }
    
    public void deleteElevationConfidence()
    {
	setComponentAbsent(6);
    }
    
    
    // Methods for field "roadSegmentID"
    public RoadSegmentID getRoadSegmentID()
    {
	return (RoadSegmentID)mComponents[7];
    }
    
    public void setRoadSegmentID(RoadSegmentID roadSegmentID)
    {
	mComponents[7] = roadSegmentID;
    }
    
    public boolean hasRoadSegmentID()
    {
	return componentIsPresent(7);
    }
    
    public void deleteRoadSegmentID()
    {
	setComponentAbsent(7);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "ReferencePosition"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "ReferencePosition"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Longitude"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Longitude"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Longitude"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Longitude"
				)
			    ),
			    0
			)
		    ),
		    "longitude",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Latitude"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Latitude"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Latitude"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Latitude"
				)
			    ),
			    0
			)
		    ),
		    "latitude",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Elevation"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Elevation"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Elevation(-10000), 
				    new Elevation(16767215),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-10000),
				new java.lang.Long(16767215)
			    ),
			    null
			)
		    ),
		    "elevation",
		    2,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Direction"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Direction"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Direction(0), 
				    new Direction(28799),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(28799)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"north",
					0
				    ),
				    new MemberListElement (
					"east",
					7200
				    ),
				    new MemberListElement (
					"south",
					14400
				    ),
				    new MemberListElement (
					"west",
					21600
				    )
				}
			    )
			)
		    ),
		    "heading",
		    3,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new KMCStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8004
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"StreetName"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"StreetName"
			    ),
			    12314,
			    new Intersection (
				new SizeConstraint (
				    new ValueRangeConstraint (
					new AbstractBounds(
					    new com.oss.asn1.INTEGER(1), 
					    new com.oss.asn1.INTEGER(32),
					    0
					)
				    )
				),
				new PermittedAlphabetConstraint (
				    IA5StringPAInfo.pa
				)
			    ),
			    new Bounds (
				new java.lang.Long(1),
				new java.lang.Long(32)
			    ),
			    IA5StringPAInfo.paInfo
			)
		    ),
		    "streetName",
		    4,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8005
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Confidence"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Confidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Confidence(0), 
				    new Confidence(15),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(15)
			    ),
			    null
			)
		    ),
		    "positionConfidence",
		    5,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8006
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Confidence"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Confidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Confidence(0), 
				    new Confidence(15),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(15)
			    ),
			    null
			)
		    ),
		    "elevationConfidence",
		    6,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8007
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"RoadSegmentID"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"RoadSegmentID"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new RoadSegmentID(0), 
				    new RoadSegmentID(99999999),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(99999999)
			    ),
			    null
			)
		    ),
		    "roadSegmentID",
		    7,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6),
			new TagDecoderElement((short)0x8007, 7)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6),
			new TagDecoderElement((short)0x8007, 7)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6),
			new TagDecoderElement((short)0x8007, 7)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8006, 6),
			new TagDecoderElement((short)0x8007, 7)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8007, 7)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' ReferencePosition object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' ReferencePosition object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for ReferencePosition
